import abc
import signal
from typing import List
from multiprocessing import Process

class Attack(object):
    _processes: List[Process]

    def __init__(self) -> None:
        self._processes = []

    @abc.abstractmethod
    def run(self):
        """"""

    def _wait_for_sigint(self):
        signal.signal(signal.SIGINT, self._sig_handler)
        print("Press Ctrl+C to exit")
        signal.pause()

    def _sig_handler(self, sig, frame):
        print("Exiting")
        for process in self._processes:
            if process is not None and process.is_alive():
                process.kill()
                process.join()

    def _wait_for_processes(self):
        for proc in self._processes:
            proc.join()
